from re import T
import sys
#sys.path.append("../python-common")

import cv2 as cv2
import numpy as np
import os
import TIS
import time
from collections import namedtuple



class CustomData:
    def __init__(self, ):
        self.imagecounter = 0
        self.busy = False

def on_new_image(tis, userdata):
    #　ビジー状態のときは回避
    if userdata.busy is True:
            return

    userdata.busy = True
    image = tis.Get_image()
    
    # 画像処理を記載
    # 例：収縮処理
    kernel = np.ones((5, 5), np.uint8)
    image = cv2.erode(image, kernel, iterations=5) 

    # 保存するJpegファイルにインデックスナンバーを付与
    userdata.imagecounter += 1;
    filename = "./image{:04}.jpg".format(userdata.imagecounter)
    
    # jpegで保存
    cv2.imwrite(filename, image)
    userdata.busy = False


Tis = TIS.TIS()
#Tis.openDevice("29910443", 640, 480, "30/1", TIS.SinkFormats.GRAY8,True)
if not Tis.selectDevice():
        quit(0)

# CustomData classをインスタンス化
CD = CustomData()
#Gstreamerのパイプラインを実行している間は画像処理を避けるためにビジーをTrueにする
CD.busy = True

# コールバック関数を定義
Tis.Set_Image_Callback(on_new_image, CD)
# トリガーモードをOFF
Tis.Set_Property("TriggerMode", "Off")  

# ホワイトバランスを定義（モノクロカメラの場合スルー）
try:
    Tis.Set_Property("BalanceWhiteAuto", "Off")
    Tis.Set_Property("BalanceWhiteRed", 1.2)
    Tis.Set_Property("BalanceWhiteGreen", 1.0)
    Tis.Set_Property("BalanceWhiteBlue", 1.4)
except Exception as error:
    print(error)

# ゲインと露光時間の自動をOFFにする
try:
    # Disable gain and exposure automatic
    Tis.Set_Property("GainAuto", "Off")
    Tis.Set_Property("Gain",0)
    Tis.Set_Property("ExposureAuto", "Off")
    Tis.Set_Property("ExposureTime", 24000)
except Exception as error:
    print(error)

Tis.Start_pipeline()

#トリガーモードOn
Tis.Set_Property("TriggerMode", "On")  
#トリガーモードをカメラに適用する待ち時間
time.sleep(0.1)

#ソフトウェアトリガーをONにする


# ループ処理
while True:
    key = input("q : quit\nPlease enter:")
    Tis.execute_command("TriggerSoftware") 

    if key == "q":
        break

Tis.Stop_pipeline()
print('Program end')